#include<pthread.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define NTHREADS 5
pthread_key_t fd_key;
pthread_once_t fd_once = PTHREAD_ONCE_INIT;

void *thread_function(void *thread_arg);
void init_module(void);
void use_module(void);
void module_destructor (void *fd);
void module_once (void);

main() {
  pthread_t thread[NTHREADS];
  int i;

  for (i = 0; i < NTHREADS; i++)
    pthread_create(&thread[i], NULL, thread_function, NULL);

  for (i = 0; i < NTHREADS; i++) 
    pthread_join(thread[i], NULL);
}

void *thread_function(void *thread_arg) {
  init_module();
  sleep(3);
  use_module();
}

void init_module(void) {
  char filename[20];
  int fd;
  pthread_once(&fd_once, module_once);
  sprintf(filename, "module_t%d.log", (int) pthread_self());
  fd = open(filename, O_RDWR | O_CREAT | O_TRUNC,  S_IRUSR | S_IWUSR); 
  pthread_setspecific(fd_key, (void *) fd);
  printf("init_module: thread %d com fd %d\n", (int)pthread_self(), fd);
}

void use_module(void) {
  int fd;
  fd = (int) pthread_getspecific(fd_key);
  printf("use_module: thread %d com fd %d\n", (int)pthread_self(), fd);
}

void module_destructor (void *fd) {
  close((int)fd);
}

void module_once (void) {
  pthread_key_create(&fd_key, module_destructor);
}
